diff --git a/gdb/annotate.c b/gdb/annotate.c
index 84940ff031a..84f8129b22d 100644
--- a/gdb/annotate.c
+++ b/gdb/annotate.c
@@ -26,6 +26,8 @@
 #include "inferior.h"
 #include "infrun.h"
 #include "top.h"
+#include "source.h"
+#include "objfiles.h"
 
 
 /* Prototypes for local functions.  */
@@ -417,7 +419,7 @@ annotate_arg_end (void)
     printf_filtered (("\n\032\032arg-end\n"));
 }
 
-void
+static void
 annotate_source (const char *filename, int line, int character, int mid,
 		 struct gdbarch *gdbarch, CORE_ADDR pc)
 {
@@ -430,6 +432,31 @@ annotate_source (const char *filename, int line, int character, int mid,
 		   mid ? "middle" : "beg", paddress (gdbarch, pc));
 }
 
+/* See annotate.h.  */
+
+bool
+annotate_source_line (struct symtab *s, int line, int mid_statement,
+		      CORE_ADDR pc)
+{
+  if (annotation_level > 0)
+    {
+      if (s->line_charpos == nullptr)
+	open_source_file_with_line_charpos (s);
+      if (s->fullname == nullptr)
+	return false;
+      /* Don't index off the end of the line_charpos array.  */
+      if (line > s->nlines)
+	return false;
+
+      annotate_source (s->fullname, line, s->line_charpos[line - 1],
+		       mid_statement, get_objfile_arch (SYMTAB_OBJFILE (s)),
+		       pc);
+      return true;
+    }
+  return false;
+}
+
+
 void
 annotate_frame_begin (int level, struct gdbarch *gdbarch, CORE_ADDR pc)
 {
diff --git a/gdb/annotate.h b/gdb/annotate.h
index ff10d459465..9683b7e09ac 100644
--- a/gdb/annotate.h
+++ b/gdb/annotate.h
@@ -87,8 +87,17 @@ struct annotate_arg_emitter
   DISABLE_COPY_AND_ASSIGN (annotate_arg_emitter);
 };
 
-extern void annotate_source (const char *, int, int, int,
-			     struct gdbarch *, CORE_ADDR);
+/* If annotations are turned on then print annotation describing the full
+   name of the source file S and the line number LINE and its corresponding
+   character position.
+
+   MID_STATEMENT is nonzero if the PC is not at the beginning of that
+   line.
+
+   Return true if successful, false if the file could not be found or
+   annotations are turned off.  */
+extern bool annotate_source_line (struct symtab *s, int line,
+				  int mid_statement, CORE_ADDR pc);
 
 extern void annotate_frame_begin (int, struct gdbarch *, CORE_ADDR);
 extern void annotate_function_call (void);
diff --git a/gdb/source.c b/gdb/source.c
index dae1801c136..dec5a2f84ba 100644
--- a/gdb/source.c
+++ b/gdb/source.c
@@ -1212,29 +1212,6 @@ open_source_file_with_line_charpos (struct symtab *s)
 
 
 
-/* See source.h.  */
-
-int
-identify_source_line (struct symtab *s, int line, int mid_statement,
-		      CORE_ADDR pc)
-{
-  if (s->line_charpos == nullptr)
-    open_source_file_with_line_charpos (s);
-  if (s->fullname == 0)
-    return 0;
-  if (line > s->nlines)
-    /* Don't index off the end of the line_charpos array.  */
-    return 0;
-  annotate_source (s->fullname, line, s->line_charpos[line - 1],
-		   mid_statement, get_objfile_arch (SYMTAB_OBJFILE (s)), pc);
-
-  current_source_line = line;
-  current_source_symtab = s;
-  clear_lines_listed_range ();
-  return 1;
-}
-
-
 /* Print source lines from the file of symtab S,
    starting with line number LINE and stopping before line number STOPLINE.  */
 
@@ -1519,8 +1496,8 @@ info_line_command (const char *arg, int from_tty)
 
 	  /* If this is the only line, show the source code.  If it could
 	     not find the file, don't do anything special.  */
-	  if (annotation_level && sals.size () == 1)
-	    identify_source_line (sal.symtab, sal.line, 0, start_pc);
+	  if (sals.size () == 1)
+	    annotate_source_line (sal.symtab, sal.line, 0, start_pc);
 	}
       else
 	/* Is there any case in which we get here, and have an address
diff --git a/gdb/source.h b/gdb/source.h
index 7ea826acae5..1c45405774b 100644
--- a/gdb/source.h
+++ b/gdb/source.h
@@ -127,17 +127,6 @@ extern void clear_current_source_symtab_and_line (void);
 /* Add a source path substitution rule.  */
 extern void add_substitute_path_rule (char *, char *);
 
-/* Print text describing the full name of the source file S
-   and the line number LINE and its corresponding character position.
-   The text starts with two Ctrl-z so that the Emacs-GDB interface
-   can easily find it.
-
-   MID_STATEMENT is nonzero if the PC is not at the beginning of that line.
-
-   Return 1 if successful, 0 if could not find the file.  */
-extern int identify_source_line (struct symtab *s, int line,
-				 int mid_statement, CORE_ADDR pc);
-
 /* Flags passed as 4th argument to print_source_lines.  */
 enum print_source_lines_flag
   {
diff --git a/gdb/stack.c b/gdb/stack.c
index 547e82bbfb2..f471efe3df7 100644
--- a/gdb/stack.c
+++ b/gdb/stack.c
@@ -47,6 +47,7 @@
 #include "linespec.h"
 #include "cli/cli-utils.h"
 #include "objfiles.h"
+#include "annotate.h"
 
 #include "symfile.h"
 #include "extension.h"
@@ -962,13 +963,11 @@ print_frame_info (const frame_print_options &fp_opts,
 
   if (source_print && sal.symtab)
     {
-      int done = 0;
       int mid_statement = ((print_what == SRC_LINE)
 			   && frame_show_address (frame, sal));
+      bool done = annotate_source_line (sal.symtab, sal.line, mid_statement,
+					get_frame_pc (frame));
 
-      if (annotation_level)
-	done = identify_source_line (sal.symtab, sal.line, mid_statement,
-				     get_frame_pc (frame));
       if (!done)
 	{
 	  if (deprecated_print_frame_info_listing_hook)